<template>
    <div class="content-grid content-grid--subpage">
        <Breadcrumbs :title="t(`routes.admin.children.users.notification.name`)" />
        <BackLinkTitle :title="`${t('notification.notifier')} ${member.firstName} ${member.lastName}`" />
        <Card>
            <form class="form"
                  novalidate
                  @submit.prevent="handleSubmit"
                  enctype="multipart/form-data">

                <FormInput v-model="notification.title"
                           type="text"
                           name="title"
                           :ref="addFormInputRef"
                           :label="t(`notification.title`)"
                           @validated="handleValidation" />

                <FormTextEditor v-model="notification.message"
                                name="message"
                                :ref="addFormInputRef"
                                :label="t(`notification.message`)"
                                @validated="handleValidation" />

                <button class="form__submit btn btn--fullscreen" type="submit">
                    {{ t("global.send") }}
                </button>
            </form>
        </Card>

        <h3>{{ t("notification.historiqueTitle") }}</h3>
        <div v-if="theNotifications!=null && theNotifications.length > 0">
            <div v-for="(notification, index) in theNotifications" :key="index">
                <Card style="margin: 10px;">
                    <p>{{ formatDate(notification.createAt) }}</p>
                    <p>{{notification.title}}</p>
                    <div v-html="notification.message" style="max-width: 100ch; word-wrap: break-word;"></div>
                </Card>
            </div>
        </div>
        <p v-else>{{ t("notification.notificationsEmpty") }}</p>
    </div>
</template>

<script lang="ts" setup>
    import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
    import BackLinkTitle from "@/components/layout/BackLinkTitle.vue";
    import FormInput from "@/components/forms/FormInput.vue";
    import FormTextEditor from "@/components/forms/FormTextEditor.vue";
    import Card from "@/components/layout/Card.vue";
    import { useI18n } from "vue3-i18n";
    import { Member } from "@/types/entities/member";
    import { Notification } from "@/types/entities/notification"
    import { notifyError, notifySuccess } from "@/notify";
    import { useMemberService, useNotificationService } from "@/inversify.config"
    import { useRouter } from "vue-router";
    import { ICreateNotificationRequest } from "../../types/requests/createNotificationRequest";
    import { ref, onMounted } from "vue";
    import { DateTime } from "luxon";

    const { t } = useI18n()
    const router = useRouter();
    const memberService = useMemberService();
    const notificationService = useNotificationService();

    // eslint-disable-next-line no-undef
    const props = defineProps<{
        id: string
    }>();

    const notification = ref<Notification>({ title: "", message: "", toMemberId: props.id });
    const theNotifications = ref<Notification[]>();
    const member = await memberService.getMemberById(props.id);
    console.log(member);

    onMounted(async () => {
        await LoadNotifications();
    })

    async function LoadNotifications() {
        let notifications = await notificationService.GetNotificationsByMemberId(props.id);
        if (notifications) {
            theNotifications.value = notifications;
            console.log(theNotifications)
        }
    }

    async function handleSubmit() {
        console.log({ notification })
        let succeededOrNotResponse = await notificationService.createNotification(notification.value as ICreateNotificationRequest);
        if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
            notifySuccess(t('validation.notification.add.success'));
            setTimeout(() => router.back(), 1500);
        } else {
            notifyError(t('validation.notification.add.errorOccured'));
        } 
    }

    function formatDate(date: string) {
        console.log("createAt: " + date)
        return DateTime.fromISO(date).toLocaleString({
            month: "long",
            day: "numeric",
            year: "numeric",
            hour: "numeric",
            minute: "2-digit",
        });
    }

</script>